// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "DeathPrefab.hpp"

using namespace Dawn;

std::string DeathPrefab::getCharacterTexture() {
  return "texture_death";
}

std::string DeathPrefab::getCharacterTileset() {
  return "tileset_death";
}

std::string DeathPrefab::getLanguagePrefix() {
  return "character.death";
}

struct VisualNovelCharacterEmotion DeathPrefab::defineAndGetInitialEmotion(
  AssetManager *man
) {
  this->emotionHappy.tile = 0;

  this->emotionConcerned.tile = 1;
  
  this->emotionSurprised.tile = 2;

  return this->emotionHappy;
}